package com.zcxk.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dto.UserGroupDto;
import com.zcxk.entity.UserEntity;
import com.zcxk.entity.UserGroup;
import com.zcxk.entity.UserRoleEntity;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 用户组(UserGroup)表数据库访问层
 *
 * @author makejava
 * @since 2020-10-27 09:13:56
 */
@Mapper
public interface UserGroupMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserGroup selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<UserGroup> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param userGroup 实例对象
     * @return 对象列表
     */
    List<UserGroup> selectList(UserGroup userGroup);

    /**
     * 新增数据
     *
     * @param userGroup 实例对象
     * @return 影响行数
     */
    int insert(UserGroup userGroup);

    /**
     * 批量新增
     *
     * @param userGroups 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(@Param("userGroups") List<UserGroup> userGroups);

    /**
     * 修改数据
     *
     * @param userGroup 实例对象
     * @return 影响行数
     */
    int update(UserGroup userGroup);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<UserGroup> selectPage(IPage<UserGroup> page, UserGroup userGroup);

    UserGroup findHasUserGroupUsers(UserGroup userGroup);
    int deleteUserGroupRelations(UserGroup userGroup);

    List<UserEntity> findUsersByUserGroup(UserGroup userGroup);
    int deleteUserRoles(@Param("userGroupDto") UserGroupDto userGroupDto);
    int batchInsertRoles(@Param("uimsUserRoles") List<UserRoleEntity> userRoleEntity);


}